#include <bits/stdc++.h>

using namespace std;

long long t,n,m,A[100000],B[100000],d,b,o;
bool p;

int main()
{
    scanf("%lld",&t);
    for(long long i=0; i<t; i++)
    {
        scanf("%lld %lld",&n,&m);
        scanf("%lld",&A[0]);
        scanf("%lld",&A[1]);
        d = abs(A[0]-A[1]);
        for(long long j=2; j<n; j++)
        {
            scanf("%lld",&A[j]);
            b = abs(A[j-1]-A[j]);
            d = __gcd(d,b);
        }
        o = A[0] % d;
        p = true;
        for(long long j=0; j<m; j++)
        {
            scanf("%lld",&B[j]);
            if(B[j]%d==o)
            {
                p = false;
            }
        }
        printf("%d\n",p);
    }
    return 0;
}